// Bentigt GLUT!
// Fr Dev-C++ (also Mingw32) siehe http://sites.netscape.net/ptrpck/glut.htm
// mit GLUT linken: Project/Project options/Further object files or linker options:
// -lopengl32 -lglu32 -lglut32

// Korrekturen fr GLUT in Dev-C++:
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE

#include <gl/glut.h>

void renderScene()
{
    glClear(GL_COLOR_BUFFER_BIT);

    glPointSize(4);
    glLineWidth(2);

    //Antialiasing fr Punkte und Linien
    glEnable(GL_POINT_SMOOTH);
    glEnable(GL_LINE_SMOOTH);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

    glBegin(GL_POINTS);
    //probiere: GL_POINTS, GL_LINES, GL_LINE_STRIP, GL_LINE_LOOP
    //GL_POLYGON, GL_QUADS, GL_TRIANGLES
    //GL_TRIANGLE_STRIP, GL_QUAD_STRIP, GL_TRIANGLE_FAN
        glColor3f(0.0, 1.0, 1.0); // 3f: drei float-Werte (C kann kein berladen ...)
        glVertex2i( 84,  39); // 2i: zwei Integer-Werte
        glVertex2i( 32, 130);
        glVertex2i( 54, 240);
        glVertex2i(167, 379);
        glVertex2i(236, 342);
        glVertex2i(310, 213);
        glVertex2i(280, 133);
        glColor3f(1.0, 0.0, 0.0);
        glVertex2i(162,  30);
    glEnd();

    // Achtung: Wenn Polygone nicht konvex und/oder nicht eben sind,
    // darf OpenGL ausrasten. Also lieber immer Dreiecke nehmen ...

    glFlush();
}

void changeSize(GLsizei w, GLsizei h)
{
    glViewport(0, 0, w, h); // ganzes Fenster nutzen
    glMatrixMode(GL_PROJECTION); // jetzt Projektionsmatrix einstellen
    glLoadIdentity(); // Einheitsmatrix laden
    gluOrtho2D(0, w, 0, h); // platt projizieren
}

int main(int argc, char* argv[])
{
    glutInit(&argc, argv);

    glutInitWindowSize(400, 400);
    glutInitWindowPosition(34, 45);

    // berflssig, da Standard: glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE);
    glutCreateWindow("GL-Zeichenbefehle");

    glutDisplayFunc(renderScene);
    glutReshapeFunc(changeSize);

    glutMainLoop();

    return 0; // wird nie erreicht
}
